/************************************************************************

	t@CFI7sPciBase.h
	TvFHRP Interface Board 07-0003
		  foCXhCoƋLf[^ݒR[hB
	XVF2008/8/23
	o[WF1.0.0
	RgF

	Copyright 2008 ZUCO

************************************************************************/
#ifndef _I7SPCIBASE_H_
#define _I7SPCIBASE_H_

#ifdef __cplusplus
extern "C" {
#endif  /* __cplusplus */


//---------------------------------------------------------------------------
//  IB7 Device Information
//---------------------------------------------------------------------------
typedef struct _IB7_DEVINFO {
	WORD	ib7no;				// Ib7 num 0-3
	WORD	irq;				// irq num
	WORD	Ib7Ver;				// Ib7 pci ver
	WORD	Ib7ID;				// Ib7 serial num (SubSystemID)
	DWORD	ioBase;				// base io address
	DWORD	ioLCR;				// base Apic LocalConfigurationRegister
} IB7_DEV_INFO, *PIB7_DEV_INFO;	// 16bytes

//---------------------------------------------------------------------------
//  IB7 Calling Parameter (I7fGetInfo)
//---------------------------------------------------------------------------
typedef struct _IB7_PARAINFO
{
	WORD			Ib7no;		// Ib7 # (0 to Max(=3))
	IB7_DEV_INFO	DevInfo;	// Parameter
} IB7_PARAINFO, *PIB7_PARAINFO;

//---------------------------------------------------------------------------
//  IB7 Calling Parameter (I7fReadVersion/I7fReadIOAddr/)
//---------------------------------------------------------------------------
typedef struct _IB7_PARA
{
	WORD	Ib7no;		// Ib7 # (0 to Max(=3))
	DWORD	dwData[2];	// Parameter
} IB7_PARA, *PIB7_PARA;

//---------------------------------------------------------------------------
//  IB7 Calling Parameter (I7fAdRead/I7fDaWrite/I7fDaChkWrite)
//---------------------------------------------------------------------------
typedef struct _IB7_ADDACH
{
	int		ch;					// Channel  (0 to 15)
	WORD	wData[2];			// Parameter
} IB7_ADDACH, *PIB7_DADDACH;

//---------------------------------// Parameter A/D
typedef struct _IB7_PARAAD
{
	WORD		Ib7no;			// Ib7 # (0 to Max(=3))
	IB7_ADDACH	ChData;			// Channel  (0 to 15)
} IB7_PARAAD, *PIB7_PARAAD;

//---------------------------------// Parameter D/A
typedef struct _IB7_PARADA
{
	WORD		Ib7no;			// Ib7 # (0 to Max(=3))
	IB7_ADDACH	ChData;			// Channel  (0 to 15)
} IB7_PARADA, *PIB7_PARADA;

//---------------------------------------------------------------------------
//  IB7 Calling Parameter (I7fEncxxxx)
//---------------------------------------------------------------------------
typedef struct _IB7_ENCCH
{
	int		ch;				// Channel  (-1, 0 to 15)
	WORD	command;		// Command
	WORD	mode;			// mode
	WORD	status;			// Status
	DWORD	dwData[2];		// Parameter
} IB7_ENCCH, *PIB7_ENCCH;

//---------------------------------// Parameter ENC
typedef struct _IB7_PARAENC
{
	WORD		Ib7no;			// Ib7 # (0 to Max(=3))
	IB7_ENCCH	ChData;			// Channel  (0 to 15)
} IB7_PARAENC, *PIB7_PARAENC;

//---------------------------------------------------------------------------
//  IB7 Calling Parameter (I7fPioxxxx)
//---------------------------------------------------------------------------
typedef struct _IB7_PIOCH
{
	int		InGroup;		// In  Groupe (0 to 3)
	int		OutGroup;		// Out Groupe (0 to 3, -1)
	WORD	ch;				// Channel    (0 to 7)
	WORD	wData;			// Parameter
} IB7_PIOCH, *PIB7_PIOCH;

//---------------------------------// Parameter PIO
typedef struct _IB7_PARAPIO
{
	WORD		Ib7no;			// Ib7 # (0 to Max(=3))
	IB7_PIOCH	ChData;			// Channel data
} IB7_PARAPIO, *PIB7_PARAPIO;

//---------------------------------------------------------------------------
#define IB7_MAXADCH			16	// Max A/D Chennel 
#define IB7_MAXDACH			16	// Max D/A Channel
#define IB7_MAXENCCH		16	// Max ENC Channel
#define IB7_PIO_OUTCHPERGRP	16	// PIO Group
#define IB7_MAXPIOINGRP		 1	// Max PIO In  Group
#define IB7_MAXPIOOUTGRP	 1	// Max PIO Out Group
#define IB7_MAXPIOCH		16	// Max PIO Channel

enum {
	ENC_MODE_PULSE,
	ENC_MODE_X1,
	ENC_MODE_X2,
	ENC_MODE_X4
};

//---------------------------------------------------------------------------
//  Function Return Code
//---------------------------------------------------------------------------
#define RTN_IBOK		 0	// OK
#define RTN_IBOVER		-1	// No I/F Board Over
#define RTN_IBNOPEN		-2	// No Open  I/F board
#define RTN_IBNOCLOSE	-3	// No Close I/F board
#define RTN_IBNOPARA	-4	// No Parameter
#define RTN_IBCHOVER	-5	// No I/F Board Channel Over
#define RTN_ENCNOMODE	-6	// No ENC Mode
#define RTN_IBOPENED	-7	// Opened  I/F board
#define RTN_IBIOCTL		-8	// IOCTL error.
#define RTN_IBTMOVER	-9	// Time over.


#ifdef __cplusplus
}
#endif

#endif //_I7SPCIBASE_H_